/*
 *     Material3Settings.kt
 *     Gugal
 *     Copyright (c) 2022 thegreatporg
 *
 *     This program is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package com.porg.gugal

import android.annotation.SuppressLint
import androidx.compose.foundation.layout.*
import androidx.compose.material3.*
import androidx.compose.runtime.Composable
import androidx.compose.ui.Modifier
import androidx.compose.ui.res.stringResource
import androidx.compose.ui.unit.dp

@Deprecated(
    "Material 3 components provided by Gugal are now in their own package, using a " +
            "more Compose-like syntax. This function will be removed in Gugal 0.9."
)
class Material3Settings {
    companion object {

        val padding = 20.dp
        val dividerPadding = 5.dp


        @Deprecated(
            "Material 3 components provided by Gugal are now in their own package, using a " +
                    "more Compose-like syntax. This function will be removed in Gugal 0.9.",
            ReplaceWith("com.porg.m3.settings.RegularSetting(title, body, onClick)")
        )
        @Composable
        fun RegularSetting(title: Int, body: Int, onClick: (() -> Unit)) {
            com.porg.m3.settings.RegularSetting(
                stringResource(title),
                stringResource(body),
                onClick
            )
        }

        @Deprecated(
            "Material 3 components provided by Gugal are now in their own package, using a " +
                    "more Compose-like syntax. This function will be removed in Gugal 0.9.",
            ReplaceWith("com.porg.m3.settings.RegularSetting(title, body, onClick)")
        )
        @Composable
        fun RegularSetting(title: String, body: String, onClick: (() -> Unit)) {
            com.porg.m3.settings.RegularSetting(
                title,
                body,
                onClick
            )
        }

        @Deprecated(
            "Material 3 components provided by Gugal are now in their own package, using a " +
                    "more Compose-like syntax. This function will be removed in Gugal 0.9.",
            ReplaceWith("com.porg.m3.settings.RegularPreviewSetting(title, body, onClick)")
        )
        @Composable
        fun BasicPreviewSetting(title: String, body: String, onClick: (() -> Unit)) {
            com.porg.m3.settings.RegularPreviewSetting(title, body, onClick)
        }

        @Deprecated(
            "Material 3 components provided by Gugal are now in their own package, using a " +
                    "more Compose-like syntax. This function will be removed in Gugal 0.9.",
            ReplaceWith("com.porg.m3.settings.PreviewChip()")
        )
        @Composable
        fun PreviewChip() {
            com.porg.m3.settings.PreviewChip()
        }

        @Deprecated(
            "Material 3 components provided by Gugal are now in their own package, using a " +
                    "more Compose-like syntax. This function will be removed in Gugal 0.9.",
            ReplaceWith("com.porg.m3.settings.RadioSetting(title, body, onClick, selected, modifier = Modifier.fillMaxWidth())")
        )
        @Composable
        fun RadioSetting(title: Int, body: Int, onClick: (() -> Unit), selected: Boolean, @SuppressLint(
            "ModifierParameter"
        ) modifier: Modifier = Modifier.fillMaxWidth()) {
            com.porg.m3.settings.RadioSetting(
                title,
                body,
                onClick,
                selected,
                modifier = Modifier.fillMaxWidth()
            )
        }

        @Deprecated(
            "Material 3 components provided by Gugal are now in their own package, using a " +
                    "more Compose-like syntax. This function will be removed in Gugal 0.9.",
            ReplaceWith("com.porg.m3.settings.RadioSetting(title, body, onClick, selected, modifier = Modifier.fillMaxWidth())")
        )
        @Composable
        fun RadioSetting(title: String, body: String, onClick: (() -> Unit), selected: Boolean, @SuppressLint(
            "ModifierParameter"
        ) modifier: Modifier = Modifier.fillMaxWidth()) {
            com.porg.m3.settings.RadioSetting(
                title,
                body,
                onClick,
                selected,
                modifier = Modifier.fillMaxWidth()
            )
        }

        @Deprecated(
            "Material 3 components provided by Gugal are now in their own package, using a " +
                    "more Compose-like syntax. This function will be removed in Gugal 0.9.",
            ReplaceWith("com.porg.m3.settings.CheckboxSetting(title, body, onCheckedChange, checked, modifier = Modifier.fillMaxWidth())")
        )
        @Composable
        fun CheckboxSetting(title: Int, body: Int, onCheckedChange: (Boolean) -> Unit, checked: Boolean, @SuppressLint(
            "ModifierParameter"
        ) modifier: Modifier = Modifier.fillMaxWidth()) {
            com.porg.m3.settings.CheckboxSetting(
                title,
                body,
                onCheckedChange,
                checked,
                modifier = Modifier.fillMaxWidth()
            )
        }

        @Deprecated(
            "Material 3 components provided by Gugal are now in their own package, using a " +
                    "more Compose-like syntax. This function will be removed in Gugal 0.9.",
            ReplaceWith("com.porg.m3.settings.CheckboxSetting(title, body, onCheckedChange, checked, modifier = Modifier.fillMaxWidth())")
        )
        @Composable
        fun CheckboxSetting(title: String, body: String, onCheckedChange: (Boolean) -> Unit, checked: Boolean, @SuppressLint(
            "ModifierParameter"
        ) modifier: Modifier = Modifier.fillMaxWidth()) {
            com.porg.m3.settings.CheckboxSetting(
                title,
                body,
                onCheckedChange,
                checked,
                modifier = Modifier.fillMaxWidth()
            )
        }

        @Deprecated(
            "Material 3 components provided by Gugal are now in their own package, using a " +
                    "more Compose-like syntax. This function will be removed in Gugal 0.9.",
            ReplaceWith("com.porg.m3.settings.ToggleSetting(title, body, onCheckedChange, selected)")
        )
        @Composable
        fun ToggleSetting(title: Int, body: Int, onCheckedChange: ((Boolean) -> Unit), selected: Boolean) {
            com.porg.m3.settings.ToggleSetting(
                stringResource(title),
                stringResource(body),
                onCheckedChange,
                selected
            )
        }

        @Deprecated(
            "Material 3 components provided by Gugal are now in their own package, using a " +
                    "more Compose-like syntax. This function will be removed in Gugal 0.9.",
            ReplaceWith("com.porg.m3.settings.ToggleSetting(title, body, onCheckedChange, selected)")
        )
        @Composable
        fun ToggleSetting(title: String, body: String, onCheckedChange: ((Boolean) -> Unit), selected: Boolean) {
            com.porg.m3.settings.ToggleSetting(
                title,
                body,
                onCheckedChange,
                selected
            )
        }
    }
}